# require "podsorz/core/PodsOrz/pods_check_merge"
# require "../../PodsOrz/lib/podsorz/core/PodsOrz/pods_check_merge.rb"
require "podsorz/core/PodsOrz/pods_check_merge"
require "podsorz/core/Config/pod_orzconfig_parse"


module PodsOrz
	def self.check_command
		desc "Check Pods not merge"
		command :check do |check|
			check.action do |global_options, options, args|
				dir_path = global_options[:path]

				is_directory = File.directory?(dir_path)

				unless is_directory
					Logger.error("Check failure, it is not a directory path: #{dir_path}")
					exit()
				end

				@orzconfig_parse = PodsOrz::PodOrzconfigParse.new(dir_path)
                kx_pods_path = File.expand_path("../#{@orzconfig_parse.file_devpods_name}", dir_path)
                # puts "kx_pods_path #{kx_pods_path}"
				checkManger = PodsOrz::PodsCheckMerge.new()
                checkManger.branchList(kx_pods_path)
			
			end
		end
	end

end
