module PodsOrz

  class PodspecModel

    attr_accessor :dependency_list, :pod_name, :have_resources

    def initialize(podspec_file_path)
      @dependency_list = []
      @have_resources = false

      totoal_sentences = []
      File.open(podspec_file_path, "r") {|io|
        totoal_sentences = io.readlines
      }

      totoal_sentences.each do |line|
        if /\.(name)(.*) =/ =~ line
          @pod_name = $~.post_match.strip
          @pod_name = pod_name.gsub(/[\'\"]/, "")
        end

        if /\.(resource)(.*) =/ =~ line
          @have_resources = true
        end

        if /\.dependency/ =~ line
          dependency = $~.post_match.strip

          unless @pod_name.nil?
            unless dependency.include? @pod_name
              @dependency_list << dependency  
            end
          end

        end
      end

    end



#class end
  end

end